function sdkp:CHAT_MSG_LOOT(event, arg1)
	-- in the case of a manually assigned loot, the event will be the reason/note
	if not self:IsTrackLoot() then 
		return;
	end
	local _, _, player, link = string.find(arg1, "([^%s]+) receives loot: (.+)%.");
	if player == nil then
		player = UnitName("player");
		_, _, link = string.find(arg1, "You receive loot: (.+)%.");
		if not link then
			return;
		end
	end
	link = link:trim();
	
	local _, _, color, _, item = string.find(link, "|c(%x+)|Hitem:(%d+)[:%d%-]+|h%[(.-)%]|h|r");	
	local amount = self:GetDkpForItem(item);
	local bids = self.db.profile.bids;
	
	if bids and bids[player:lower()] then 
		amount = bids[player:lower()];
	end
	
	if (self:GetLootFilter(nil, SDKP_ICOLORS[color])) and (not self:IsIgnoreLoot(item)) then
		self:EnqueueDialog(
			"How much did |c00ffff00" .. player .. "|r spend on\n" .. link .. "?",
			"Ok", 
			"Cancel", 
			function (cost)
				if self:IsShroudDkp() then
					local pdata = self:getPlayerData(player:lower());
					local dkp = pdata.cols[7].value;
						if type(dkp) == "function" then 
							--data, cols, realrow, column, table
							dkp = dkp(unpack({self.BIDSCROLLFRAME.data, self.BIDSCROLLFRAME.cols, SDKPPLAYER[pdata.cols[1].value:lower()], 7, self.BIDSCROLLFRAME}));
						end
					cost = cost/100 * dkp;
				end
				sdkp:SendMessage("SDKP_LOOT_ASSIGNED", player, link, cost, event);
			end,
			function()end,
			amount
		); 
		self:ConfirmPopup();
	end
end

function sdkp:PLAYER_REGEN_ENABLED(event)
	self:ConfirmPopup();
end

function sdkp:CHAT_MSG_WHISPER(event, text, from, ...)
	local _, _, wCmd, wCmdArgs = text:find("^(![^%s]+)%s*(.*)");
	if wCmd then 
		wCmd = wCmd:lower();
		if wCmd == "!bid" and event == self:GetBidChannel() then
			self:WCmdBid(from, wCmdArgs);
		elseif wCmd == "!help" then
			self:WCmdHelp(from);
		elseif wCmd == "!here" then
			self:WCmdHere(from);
		elseif wCmd == "!waitlist" or wCmd == "!wl" then
			self:WCmdWaitlist(from, wCmdArgs);
		elseif wCmd == "!dkp" then
			self:WCmdDKP(from, wCmdArgs);
		elseif wCmd == "!attendance" or wCmd == "!att" then
			self:WCmdAttn(from, wCmdArgs);
		end
	end
end
function sdkp:CHAT_MSG_GUILD(event, text, from, ...)
	local _, _, wCmd, wCmdArgs = text:find("^(![^%s]+)%s*(.*)");
	if wCmd then 
		wCmd = wCmd:lower();
		if wCmd == "!bid" and event:find(self:GetBidChannel()) then
			self:WCmdBid(from, wCmdArgs);
		end
	end
end
sdkp.CHAT_MSG_RAID = sdkp.CHAT_MSG_GUILD;
sdkp.CHAT_MSG_OFFICER = sdkp.CHAT_MSG_GUILD;
sdkp.CHAT_MSG_RAID_LEADER = sdkp.CHAT_MSG_GUILD;

function sdkp:LOOT_OPENED(event, ...)
	if self:IsTrackLoot() then 
		self:Debug("Loot window opened...");
		local loot_target = UnitName("target");
		local isBossLoot = false;
		self:Debug(loot_target, GetRealZoneText(), GetSubZoneText(),SDKP_RAID_ZONE[GetRealZoneText()]);
		if SDKP_RAID_ZONE[GetRealZoneText()] then 
			self.LOOT_WINDOW = {};
			local i;
			for i = 1, GetNumLootItems() do
		 		if LootSlotIsItem(i) then
		   			local link = GetLootSlotLink(i);
		   			local _, _, color, id, item = string.find(link, "|c(%x+)|Hitem:([^:]+)[:%d%-]+|h%[(.-)%]|h|r");
					if (self:GetLootFilter(nil, SDKP_ICOLORS[color])) and (not self:IsIgnoreLoot(item)) then
						self.LOOT_WINDOW[link]=link;
					end
					if SDKP_EMBLEMS[id] then 
		   				isBossLoot = true;
		   			end
		 		end
		   	end
		   	local english_boss = self.bb[loot_target];
		   	self:Debug(english_boss, SDKP_UNIT_BOSS_IGNORE[english_boss]);
		   	
		   	-- Going to try my best to figure out what boss it is here.  Loot is probably a chest or something
		   	if not english_boss and isBossLoot then 
		   		-- Look up the subzone in the zone to encounter table
		   		english_boss = SDKP_ZONE_TO_ENCOUNTER[ GetSubZoneText()];
		   	end
		   	
		   	if english_boss and not SDKP_UNIT_BOSS_IGNORE[english_boss] then
				self:CmdSnapshot(info, SDKP_UNIT_TO_ENCOUNTER[english_boss] or english_boss, self.LOOT_WINDOW);	
			end
	   	end
	end
end

function sdkp:ZONE_CHANGED_NEW_AREA(event, ...)
	local zone = GetRealZoneText();
	if not SDKP_RAID_ZONE[zone] and self:IsTrackLoot(nil) and not UnitIsDeadOrGhost("player") then 
		self:Debug("Turning off loot tracking since we are leaving the instance.");
		self:ToggleTrackLoot(nil, false); -- 
	elseif SDKP_RAID_ZONE[zone] and not(self:IsTrackLoot(nil) or self.db.profile.was_ghost) then
		self:Debug("Entering instance, but not after a ghost run... track loot is off... turn on?");
		self:EnqueueDialog(
			"|cffff7d0aSDKP|r\nWould you like to turn loot tracking on?",
			"Yes", 
			"No", 
			function ()
				sdkp:ToggleTrackLoot(nil, true);
			end
		);
		self:ConfirmPopup();
	end
	self.db.profile.was_ghost = UnitIsDeadOrGhost("player");
end

function sdkp:SDKP_LOOT_ASSIGNED(event, player, link, cost, note)
	if not self.db.profile.loot then
		self.db.profile.loot = {};
	end
	
	player = self:GetAltInfo(player);
	local pdata = self:getPlayerData(player);
	
	local color, id, item;
	if link == "Major Noobery" or link == "Minor Noobery" or link == "Fakery" then 
		color, id, item = "ffff8000", "", link; -- don't tax nooberies.
	else
		_, _, color, id, item = string.find(link, "|c(%x+)|Hitem:(%d+)[:%d%-]+|h%[(.-)%]|h|r");
		-- TAX
		if pdata then 
			local dkp = pdata.cols[7].value;
			if type(dkp) == "function" then 
				sdkp:Debug("Value is function. Evaluating...");
				dkp = dkp(unpack({self.BIDSCROLLFRAME.data, self.BIDSCROLLFRAME.cols, SDKPPLAYER[player:lower()], 7, self.BIDSCROLLFRAME}));
			end
			sdkp:Debug("player's dkp value: " .. dkp);
			if dkp > self:GetTaxThreshold() and not( string.find(item, "Noobery")) and not( self:IsShroudDkp()) then 
				-- nooberies are not taxed.
				sdkp:Debug("Applying tax:", self:GetTaxRate(),"-- because player has more than", self:GetTaxThreshold(), "dkp");
				cost = cost * (1 + sdkp:GetTaxRate()); -- tax
				note = note .. " [tax included]"
			end
		end
	end 
	local namecolor = sdkp.COLOR_UNKNOWN_CLASS;
	if pdata then 
		namecolor = pdata.cols[1].color;
	end
	
	local timestamp = time();
	table.insert(self.db.profile.loot, {
		["cols"] = {
			{
				["value"] = timestamp,
				["id"] = id, 
			}, -- item texture
			{ 
				["value"] = player, 
				["color"] = namecolor,
			}, -- winner
			{
				["value"] = cost,
				["color"] = { ["r"]=1, ["g"]=1, ["b"]=1, ["a"]=1.0,},
			}, -- cost
		},
		["player"] = player, 
		["item"] = item, 
		["price"] = cost, 
		["id"] = id, 
		["timestamp"] = timestamp, 
		["note"] = note,
		["color"] = color,
		["link"] = link,
	});	
	
	self:Debug("|c00ffff00" .. player .. "|r spent " .. cost .. " on " .. link .. " (" .. note .. ")");
	self:Debug(event, color, id, item);
	self:RefreshScrollTables();
end

function sdkp:READY_CHECK(event, player, ...)
	self:Debug("Ready check fired. " .. player);
	
	local main = self:GetAltInfo(player);
	local mainRankString, mainRank = self:getPlayerRank(main);
	if not mainRank then
		self:Debug(player .. " is not in " .. GetGuildInfo("player") .. ".");
	elseif mainRank < 4 then
		self:Debug(player .. "'s rank is " .. mainRankString .. ", updating raid presence list.");
		self:UpdateRaidPresence() -- function call to update presence list
	elseif GetGuildInfo("player") == "TG" and mainRank == 5 then
		self:Debug(player .. "'s rank is " .. mainRankString .. ", updating raid presence list.");
		self:UpdateRaidPresence() -- function call to update presence list
	end
end